#!/bin/sh

case "$APKG_PKG_STATUS" in
	install)
		#set default interface
		ROUTE=`route -n | sed -n 3p | awk '{print $NF}'`
		DLAN=`grep -B1 $ROUTE /etc/nas.conf |sed 2d |sed 's/\[//'|sed 's/\]//'`
		sed -i "s/interface = .*/interface = \\$DLAN/" /usr/local/AppCentral/vpn-server/etc/vpnserver.config
		grep \\[xl2tp\\] /usr/local/AppCentral/vpn-server/etc/vpnserver.config || (echo  "[xl2tp]" >> /usr/local/AppCentral/vpn-server/etc/vpnserver.config && echo "enableserver = No" >> /usr/local/AppCentral/vpn-server/etc/vpnserver.config)
		#generate new cert
		/usr/local/AppCentral/vpn-server/bin/new_cert.sh
		;;
	upgrade)
		# Backup the previous configure file.
		cp -af $APKG_TEMP_DIR/user.config $APKG_PKG_DIR/etc
		cp -af $APKG_TEMP_DIR/vpnserver.config $APKG_PKG_DIR/etc
		cp -af $APKG_TEMP_DIR/group.config $APKG_PKG_DIR/etc
		cp -af $APKG_TEMP_DIR/log.db $APKG_PKG_DIR/etc
		cp -af $APKG_TEMP_DIR/pptpd.conf $APKG_PKG_DIR/etc/pptpd
		cp -af $APKG_TEMP_DIR/options.pptpd $APKG_PKG_DIR/etc/pptpd
		cp -af $APKG_TEMP_DIR/server.conf $APKG_PKG_DIR/etc/openvpn
		cp -af $APKG_TEMP_DIR/asustor.ovpn $APKG_PKG_DIR/etc/openvpn
		# add xl2tp config
		grep \\[xl2tp\\] /usr/local/AppCentral/vpn-server/etc/vpnserver.config || (echo  "[xl2tp]" >> /usr/local/AppCentral/vpn-server/etc/vpnserver.config && echo "enableserver = No" >> /usr/local/AppCentral/vpn-server/etc/vpnserver.config)
		;;
	*)
		;;
esac

exit 0
