Ext.define('AS.ARC.apps.vpnServer.core.search', {
	extend: 'Ext.container.Container',

	alias: ['widget.asVpnSearch'],

	width: 183,
	layout: 'hbox',

	initComponent: function () {
		var me = this;

		me.addEvents('change');

		me.items = [
			{
				xtype: 'container',
				height: 25,
				width: 25,
				margin: '0 0 0 3',
				style: 'background-image:url(' + AS.ARC.util.getUserAppsPath() + 'vpn-server/images/filter.png);' +
					'background-position:center center;'
			},
			{
				xtype: 'textfield',
				itemId: 'text',
				height: 25,
				emptyText: _S('COMMON', 'FILTER'),
				enableKeyEvents: true,
				checkChangeBuffer: AS.ARC.config.keyBuffer,
				listeners: {
					change: function (text, newValue, oldValue) {
						me.fireEvent('change', me, newValue, oldValue);
					}
				}
			}
		];

		me.callParent(arguments);

	},

	getValue: function (){
		var me = this;
		return me.items.get('text').getValue();
	},

	beforeDestroy: function () {
		var me = this;

		me.callParent(arguments);
	}
});

Ext.define('AS.ARC.apps.vpnServer.overview.overview', {
	extend: 'AS.ARC.apps.vpnServer.page',
	pageTag: 'overview',
	getPanel: function () {
		var page = this;

		//var fn = this;

		var pptpToggle = Ext.create('Ext.ux.toggleslide.ToggleSlide', {
			itemId: 'pptp-toggle',
			onText: '',
			offText: '',			
			onLabelCls: 'appctl-toggle-on',
			offLabelCls: 'appctl-toggle-off',
			width: 48,
			height: 22,
			onLabelWidth: 48,
			offLabelWidth: 48,
			onLabelHeight: 22,
			offLabelHeight: 22,
			doEnableServer: function (enabled) {
				page.fn.app.maskWin(_S('COMMON', 'LOADING'));
				var me = this;
				AS.ARC.ajax({
					url: AS.ARC.util.getApiUrlWithSid(page.fn.apiUrl, {
						act: 'set',
						section: 'settings',
						tab: 'pptp'
					}),
					params: {
						enableserver: enabled
					},
					method: 'post',
					success: function (json, opts) {
						page.fn.app.unmaskWin();
						clearTimeout(page.vpnServerTimeoutId);						
						page.loadData();
					},
					failure: function (json, opts) {
						//recovery
						me.moveHandle(!enabled);
						me.state = !enabled;
						page.fn.app.unmaskWin();
						AS.ARC.util.showMsgWindow({
                            5804: _S('VPN_SERVER', 'IP_USED')
						}, json, fn.win);
					}
				});
			},
			listeners: {
				change: function (me, state) {
					me.doEnableServer(state)
				}
			}
		});

		var openvpnToggle = Ext.create('Ext.ux.toggleslide.ToggleSlide', {
			itemId: 'openvpn-toggle',
			onText: '',
			offText: '',
			onLabelCls: 'appctl-toggle-on',
			offLabelCls: 'appctl-toggle-off',
			width: 48,
			height: 22,
			onLabelWidth: 48,
			offLabelWidth: 48,
			onLabelHeight: 22,
			offLabelHeight: 22,
			doEnableServer: function (enabled) {
				page.fn.app.maskWin(_S('COMMON', 'LOADING'));
				var me = this;
				AS.ARC.ajax({
					url: AS.ARC.util.getApiUrlWithSid(page.fn.apiUrl, {
						act: 'set',
						section: 'settings',
						tab: 'openvpn'
					}),
					params: {
						enableserver: enabled
					},
					method: 'post',
					success: function (json, opts) {
						page.fn.app.unmaskWin();
						clearTimeout(page.vpnServerTimeoutId);						
						page.loadData();
					},
					failure: function (json, opts) {
						//recovery
						me.moveHandle(!enabled);
						me.state = !enabled;
						page.fn.app.unmaskWin();
						AS.ARC.util.showMsgWindow({
                            5804: _S('VPN_SERVER', 'IP_USED')
						}, json, fn.win);
					}
				});
			},
			listeners: {
				change: function (me, state) {
					me.doEnableServer(state);
				}
			}
		});

		var xl2tpToggle = Ext.create('Ext.ux.toggleslide.ToggleSlide', { // TODO
			itemId: 'xl2tp-toggle',
			onText: '',
			offText: '',
			onLabelCls: 'appctl-toggle-on',
			offLabelCls: 'appctl-toggle-off',
			width: 48,
			height: 22,
			onLabelWidth: 48,
			offLabelWidth: 48,
			onLabelHeight: 22,
			offLabelHeight: 22,
			doEnableServer: function (enabled) {
				page.fn.app.maskWin(_S('COMMON', 'LOADING'));
				var me = this;
				AS.ARC.ajax({
					url: AS.ARC.util.getApiUrlWithSid(page.fn.apiUrl, {
						act: 'set',
						section: 'settings',
						tab: 'xl2tp'
					}),
					params: {
						enableserver: enabled
					},
					method: 'post',
					success: function (json, opts) {
						page.fn.app.unmaskWin();
						clearTimeout(page.vpnServerTimeoutId);						
						page.loadData();
					},
					failure: function (json, opts) {
						//recovery
						me.moveHandle(!enabled);
						me.state = !enabled;
						page.fn.app.unmaskWin();
						AS.ARC.util.showMsgWindow({
                            5804: _S('VPN_SERVER', 'IP_USED')
						}, json, fn.win);
					}
				});
			},
			listeners: {
				change: function (me, state) {
					me.doEnableServer(state);
				}
			}
		});

		var connSet = Ext.create(Ext.form.FieldSet, {
			title: _S('VPN_SERVER', 'CONNECTIONS'),
			//layout: 'fit',
			cls: 'app-vpn-conn-fieldset',
			items: [
				{
					xtype: 'container',
					layout: 'column',
					//height: 250,
					padding: 0,
					margin: 0,
					items: [
						{
							xtype: 'container',
							height: 140,
							columnWidth: 0.33,
							layout: {
								type: 'vbox', 
								align: 'stretch'
							},
							items: [
								{
									xtype: 'container',
									style: 'background-image: url(' + page.fn.imageUrl + 'pptp.png);'+
										'background-position: center center;'+
										'background-repeat: no-repeat;',
									height: 85
								},
								{
									xtype: 'container',
									height: 55,
									layout: {
										type: 'vbox', 
										align: 'stretch'
									},
									items: [
										{
											xtype: 'container',
											flex: 1,
											style: 'text-align:center;',											
											autoEl: {
												tag: 'div',
												html: _S('VPN_SERVER', 'PPTP')
											}
										},
										{
											xtype: 'container',
											flex: 2,
											cls: 'vpn-toggle-button',
											items: [
												{
													xtype: 'container',
													cls: 'slide-container',
													items: [pptpToggle]
												}												
											]
										}
									]
								}								
							]
						},
						{
							xtype: 'container',
							height: 140,
							columnWidth: 0.33,
							layout: {
								type: 'vbox', 
								align: 'stretch'
							},
							items: [
								{
									xtype: 'container',
									style: 'background-image: url(' + page.fn.imageUrl + 'openvpn.png);' +
										'background-position: center center;' +
										'background-repeat: no-repeat;',
									height: 85
								},
								{
									xtype: 'container',
									height: 55,
									layout: {
										type: 'vbox', 
										align: 'stretch'
									},
									items: [
										{
											xtype: 'container',
											flex: 1,
											style: 'text-align:center;',
											autoEl: {
												tag: 'div',
												html: _S('VPN_SERVER', 'OPENVPN')
											}
										},
										{
											xtype: 'container',
											flex: 2,
											cls: 'vpn-toggle-button',
											items: [
												{
													xtype: 'container',
													cls: 'slide-container',
													items: [openvpnToggle]
												}	
											]
										}
									]
								}
							]
						},
						{
							xtype: 'container',
							height: 140,
							columnWidth: 0.33,
							layout: {
								type: 'vbox', 
								align: 'stretch'
							},
							items: [
								{
									xtype: 'container',
									style: 'background-image: url(' + page.fn.imageUrl + 'xl2tp.png);' +
										'background-position: center center;' +
										'background-repeat: no-repeat;',
									height: 85
								},
								{
									xtype: 'container',
									height: 55,									
									layout: {
										type: 'vbox', 
										align: 'stretch'
									},
									items: [
										{
											xtype: 'container',
											flex: 1,
											style: 'text-align:center;',
											autoEl: {
												tag: 'div',
												html: _S('VPN_SERVER', 'XL2TP')
											}
										},
										{
											xtype: 'container',
											flex: 2,
											cls: 'vpn-toggle-button',
											items: [
												{
													xtype: 'container',
													cls: 'slide-container',
													items: [xl2tpToggle]
												}	
											]
										}
									]
								}
							]
						}
					]
				}
			]
		});

		var connStore = Ext.create(Ext.data.Store, {
			autoLoad: false,
			fields: ['name', 'user', 'clientip', 'dynamicip', 'protocol', 'time'],
			proxy: {
				type: 'ajax',
				url: AS.ARC.util.getApiUrlWithSid(page.fn.apiUrl, {
					act: 'get',
					section: 'overview'
				}),
				actionMethods: {
					create: 'POST',
					read: 'POST',
					update: 'POST',
					destroy: 'POST'
				},
				reader: {
					type: 'json',
					root: 'user'
				}
			},
			listeners: {
				beforeload: function (me) {
					if (connStore.isMask) 
						page.fn.app.win.el.mask(_S('COMMON', 'LOADING'));

					me.isMask = true;	// 3.0 debug
				},
				load: function (me) {

					// 視窗關閉後直接結束
					if (!page.fn.app.win.el)
						return;

					// 新增判斷目前顯示的是否為功能頁，防止其他功能頁開啟 Sub Window 後又被 unmask
					if (connStore.isMask && page.fn.app.selectIndex === 0)
						page.fn.app.win.el.unmask();

					me.isMask = false;	// 3.0 debug

					page.vpnServerTimeoutId = Ext.defer(function () {
						clearTimeout(page.vpnServerTimeoutId);
						me.isMask = false;
						me.load();
					}, 5000);

					if (connStore.isLoading()) return false;
					var json = me.proxy.reader.jsonData;
					
					if (pptpToggle.state !== json.pptp) {
						pptpToggle.moveHandle(json.pptp);
						pptpToggle.state = json.pptp;
						//pptpToggle.toggle();
					}
					
					if (openvpnToggle.state !== json.openvpn) {
						openvpnToggle.moveHandle(json.openvpn);
						openvpnToggle.state = json.openvpn;
						//openvpnToggle.toggle();
					}

					if (xl2tpToggle.state !== json.xl2tp) {
						xl2tpToggle.moveHandle(json.xl2tp);
						xl2tpToggle.state = json.xl2tp;
						//openvpnToggle.toggle();
					}
				},
				exception: function (proxy, response, operation, opts) {
					AS.ARC.util.showMsgWindow({
					}, Ext.JSON.decode(response.responseText), page.fn.app.win);
				}
			}
		});

		var connGrid = Ext.create(Ext.grid.Panel, {
			itemId: 'grid',
			cls: 'grid-priv',
			height: 160,
			columns: [
				{
					dataIndex: 'name',
					flex: 1,
					align: 'center',
					header: _S('COMMON', 'NAME'),
					menuDisabled: true,
					renderer: function (value, metadata) {
						metadata.tdAttr = 'data-qtip="' + value + '"';
						return value;
					}
				},
				{
					dataIndex: 'clientip',
					flex: 1,
					align: 'center',
					header: _S('VPN_SERVER', 'CLIENT_IP'),
					menuDisabled: true,
					renderer: function (value, metadata) {
						metadata.tdAttr = 'data-qtip="' + value + '"';
						return value;
					}
				},
				{
					dataIndex: 'dynamicip',
					flex: 1,
					align: 'center',
					header: _S('VPN_SERVER', 'DYNAMIC_IP'),
					menuDisabled: true,
					renderer: function (value, metadata) {
						metadata.tdAttr = 'data-qtip="' + value + '"';
						return value;
					}
				},
				{
					dataIndex: 'protocol',
					flex: 1,
					align: 'center',
					header: _S('VPN_SERVER', 'PROTOCOL'),
					menuDisabled: true,
					renderer: function (value, metadata) {
						metadata.tdAttr = 'data-qtip="' + value + '"';
						return value;
					}
				},
				{
					dataIndex: 'time',
					flex: 2,
					align: 'center',
					header: _S('VPN_SERVER', 'UPTIME'),
					menuDisabled: true,
					renderer: function (value, metadata) {						
						var minUnit = 60,
							hrUnit = 60 * minUnit;

						var hrValue = Math.floor(value / hrUnit),
							restValue = value % hrUnit,
							minValue = Math.floor(restValue / minUnit);

						var result = hrValue + ' ' + _S('COMMON', 'HOURS') + ' ' + minValue + ' ' + _S('COMMON', 'MINUTES')

						metadata.tdAttr = 'data-qtip="' + result + '"';

						return result;
					}
				},
				{
					xtype: 'templatecolumn',
					dataIndex: '',
					align: 'center',
					width: 60,
					//header: _S('COMMON', 'ACTION'),
					menuDisabled: true,
					tpl: new Ext.XTemplate(
						'<div class="vpn-grid-template" style="text-align:center;" name="diconnect">',
							'<div class="vpn-btn" name="diconnect">',
								'<div class="vpn-icon" name="diconnect" data-qtip="' + _S('COMMON', 'DISCONNECT') + '"></div>',
							'</div>',
						'</div>'
					)
				}
			],
			store: connStore,
			doDisconn: function (ip) {
				var me = this;
				//do disconnect
				page.fn.app.win.el.mask(_S('COMMON', 'LOADING'));
				AS.ARC.ajax({
					url: AS.ARC.util.getApiUrlWithSid(page.fn.apiUrl, {
						act: 'disconnect',
						section: 'overview'
					}),
					params: {
						ip: ip
					},
					method: 'post',
					success: function (json, opts) {
						page.fn.app.win.el.unmask();
						me.store.load();
					},
					failure: function (json, opts) {
						page.fn.app.win.el.unmask();
						AS.ARC.util.showMsgWindow({
							
						}, json, page.fn.app.win);
					}
				});
			},
			listeners: {
				itemclick: function (me, record, item, index, e) {
					if (e.target.getAttribute('name') === 'diconnect') {
						connGrid.doDisconn(record.data.dynamicip);
					}
				}
			}
		});

		var curConn = Ext.create(Ext.form.FieldSet, {
			title: _S('VPN_SERVER', 'CURRENT_CONNECTIONS'),
			items: [
				{
					xtype: 'asPanelToolbarTop',
					items: [
						{
							xtype: 'asSearchField',
							listeners: {
								change: function (me, newValue) {
									connGrid.store.clearFilter();
									if (newValue !== '') {
										connGrid.store.filter([
											{
												filterFn: function (item) {
													var data = item.data;
													if (data.name.indexOf(newValue) !== -1)
														return true;
													if (data.clientip.indexOf(newValue) !== -1)
														return true;
													if (data.dynamicip.indexOf(newValue) !== -1)
														return true;
													if (data.protocol.indexOf(newValue) !== -1)
														return true;
												}
											}
										]);
									}
								}
							}
						}
					]
				},				
				connGrid
			]
		});

		/*var panel = Ext.create('AS.ARC.panelTop10', {
			itemId: 'panel-overview',
			cls: 'as-page-panel',
			layout: 'anchor',
			items: [
				connSet,
				curConn
			],
			loadData: function () {
				//connGrid.store.isMask = true;
				//connGrid.store.load();
			},
			listeners: {
				beforeshow: function (me) {
					me.loadData();
				},
				afterrender: function (me) {
					me.loadData();
				}
			}
		});*/

        
		return {
			xtype: 'asFnForm',
			page: page,
			itemId:  page.panelItemId,
			title: _S('VPN_SERVER', 'OVERVIEW'),
			border: false,
			cls: 'as-page-panel',
			items: [
				//panel
				connSet,
				curConn

            ],
			listeners: {
				beforeshow: function (me) {
					page.loadData();
				},
				afterrender: function (me) {
					page.loadData();
				}
			}
		};
	},

	loadData: function () {
		var page = this,
			fsetConnection = page.panelItems.items[0],
			fsetCurConn =  page.panelItems.items[1],
			connGrid = fsetCurConn.down('[itemId=grid]');
		connGrid.store.isMask = true;
		connGrid.store.load();
	}
});

/**
 * @class AS.ARC.apps.vpnServer.overview.fn
 * @extends AS.ARC.apps.vpnServer.fn
 * <p></p>
 */
Ext.define('AS.ARC.apps.vpnServer.overview.fn', {
	extend: 'AS.ARC.apps.vpnServer.fn',

	fnTag: 'overview',
	
	init: function (config) {
		this.apiUrl = AS.ARC.util.getUserAppsPath() + 'vpn-server/vpnserver.cgi';
		this.imageUrl = AS.ARC.util.getUserAppsPath() + 'vpn-server/images/';
		
		this.createPanel();
		//this.loadData();
	},

	createPanel: function () {
		var fn = this;
		
		var pageOverview = new AS.ARC.apps.vpnServer.overview.overview({fn: this});
			
		this.tabPanel = Ext.create('AS.ARC.fnTabPanel', {
			items: [
				pageOverview.getPanel()
			],
			listeners: {
				tabchange: function(tabpanel) {
					var activeIndex = tabpanel.items.indexOf(tabpanel.getLayout().activeItem);
				}
			}
		});

		//fn.tabPanel.enableDataConfirm();
		fn.initMainPanel();
	},
	
	loadData: function () {
		this.tabPanel.activeTab.page.loadData(true);
	}
});